module(..., package.seeall)

PI = 3.14159265359
ERadius = 6371.393
function getDistance( lat1, lng1, lat2, lng2 )
    -- body
    local radLat1 = lat1 * (PI / 180)
    local radLat2 = lat2 * (PI / 180)

    local a = radLat1 - radLat2
    local b = (lng1 * (PI / 180)) - (lng2 * (PI / 180))
    
    local s = 2 * math.asin(math.sqrt(math.pow(math.sin(a/2),2) + math.cos(radLat1)*math.cos(radLat2)*math.pow(math.sin(b/2),2)))
    local s = s * ERadius
    local s = math.floor(s * 10000+0.5) / 10000
    return s
end

function getPresentAfterHmac( str )
    -- body
    
    if type(str) ~= "string" then
        -- body
        return false
    end
    sha1Str = crypto.sha1(str)
    return  sha1Str:sub(1,2)
end

function guid()
    math.random( 1,32 )
    math.randomseed(os.time())
    local seed={'e','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'}
    local tb={}
    for i=1,32 do
        table.insert(tb,seed[math.random(1,16)])
    end
    local sid=table.concat(tb)
    return string.format('%s-%s-%s-%s-%s',
        string.sub(sid,1,8),
        string.sub(sid,9,12),
        string.sub(sid,13,16),
        string.sub(sid,17,20),
        string.sub(sid,21,32)
    )
end
